/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.viewers.FieldViewer3D.TabbedUI;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.Vector;
import javax.swing.JPanel;

/**
 *
 * @author vis
 */
public class UITab extends javax.swing.JPanel
{

    private String title;
    private Vector<JPanel> uiPanels = new Vector<JPanel>();
    private boolean active = true;

    /**
     * Creates new form UITab
     */
    public UITab()
    {
        this("tab");
    }

    public UITab(String title)
    {
        this.title = title;
        initComponents();
        updateGUI();
    }

    public UITab(String title, JPanel ui)
    {
        this(title);
        addUI(ui);
    }

    public void updateGUI()
    {
        uiPanel.removeAll();
        int height = 0;
        for (int i = 0; i < uiPanels.size(); i++) {
            height += uiPanels.get(i).getPreferredSize().height;
        }
        uiPanel.setMinimumSize(new Dimension(uiPanel.getPreferredSize().width, height));
        uiPanel.setPreferredSize(new Dimension(uiPanel.getPreferredSize().width, height));

        uiPanel.setLayout(new GridBagLayout());

        GridBagConstraints gridBagConstraints;
        for (int i = 0; i < uiPanels.size() - 1; i++) {
            gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = i;
            gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
            gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
            gridBagConstraints.weightx = 1.0;
            uiPanel.add(uiPanels.get(i), gridBagConstraints);
        }
        if (uiPanels.size() > 0) {
            gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = uiPanels.size() - 1;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.weighty = 1.0;
            uiPanel.add(uiPanels.get(uiPanels.size() - 1), gridBagConstraints);
        }
        //uiPanel.revalidate();
        uiPanelScrollPane.setViewportView(uiPanel);
        //revalidate();
        //repaint();
    }

    public void addUI(JPanel ui)
    {
        if (ui == null)
            return;

        uiPanels.add(ui);
        updateGUI();
    }

    public void removeUI(JPanel ui)
    {
        uiPanels.remove(ui);
        updateGUI();
    }

    public Vector<JPanel> getUIs()
    {
        return uiPanels;
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        uiPanelScrollPane = new javax.swing.JScrollPane();
        uiPanel = new javax.swing.JPanel();

        setMaximumSize(new java.awt.Dimension(216, 2147483647));
        setMinimumSize(new java.awt.Dimension(216, 600));
        setLayout(new java.awt.BorderLayout());

        uiPanelScrollPane.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

        uiPanel.setMinimumSize(new java.awt.Dimension(200, 200));
        uiPanel.setPreferredSize(new java.awt.Dimension(200, 800));
        uiPanel.setLayout(new java.awt.GridBagLayout());
        uiPanelScrollPane.setViewportView(uiPanel);

        add(uiPanelScrollPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel uiPanel;
    private javax.swing.JScrollPane uiPanelScrollPane;

    // End of variables declaration//GEN-END:variables
    /**
     * @return the title
     */
    public String getTitle()
    {
        return title;
    }

    /**
     * @param title the title to set
     */
    public void setTitle(String title)
    {
        this.title = title;
    }

    /**
     * @return the active
     */
    public boolean isActive()
    {
        return active;
    }

    /**
     * @param active the active to set
     */
    public void setActive(boolean active)
    {
        this.active = active;
    }

}
